diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -1,7 +1,7 @@
 // -*- C++ -*-
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2005-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -1113,26 +1113,34 @@
       bool C_OUT = C_FLAG;\
       u32 value;\
       \
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_LSL_REG\
       } else {\
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1148,6 +1156,12 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_LSR_REG\
       } else {\
@@ -1156,20 +1170,22 @@
       }\
       \
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1185,6 +1201,12 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ASR_REG\
       } else {\
@@ -1198,20 +1220,22 @@
       }\
       \
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1227,26 +1251,34 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ROR_REG\
       } else {\
         LOGICAL_RRX_REG\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1256,12 +1288,17 @@
   case BASE+1:\
     {\
        /* OP Rd,Rb,Rm LSL Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -1276,20 +1313,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1299,12 +1338,17 @@
   case BASE+3:\
     {\
        /* OP Rd,Rb,Rm LSR Rs */ \
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -1319,20 +1363,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1342,12 +1388,17 @@
   case BASE+5:\
     {\
        /* OP Rd,Rb,Rm ASR Rs */ \
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift < 32) {\
         if(shift) {\
           LOGICAL_ASR_REG\
@@ -1364,20 +1415,22 @@
         }\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1387,12 +1440,17 @@
   case BASE+7:\
     {\
        /* OP Rd,Rb,Rm ROR Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         shift &= 0x1f;\
         if(shift) {\
@@ -1406,20 +1464,22 @@
         C_OUT = (value & 0x80000000 ? true : false);\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1448,26 +1508,34 @@
       int dest = (opcode >> 12) & 0x0F;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ROR_IMM\
       } else {\
         value = opcode & 0xff;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1484,6 +1552,12 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       \
       if(shift) {\
         LOGICAL_LSL_REG\
@@ -1491,20 +1565,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1519,6 +1595,12 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_LSR_REG\
       } else {\
@@ -1527,20 +1609,22 @@
       }\
       \
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1555,6 +1639,12 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ASR_REG\
       } else {\
@@ -1568,20 +1658,22 @@
       }\
       \
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1596,26 +1688,34 @@
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ROR_REG\
       } else {\
         LOGICAL_RRX_REG\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1625,11 +1725,16 @@
   case BASE+1:\
     {\
        /* OP Rd,Rb,Rm LSL Rs */\
-      clockTicks++;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -1644,20 +1749,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1667,11 +1774,16 @@
   case BASE+3:\
     {\
        /* OP Rd,Rb,Rm LSR Rs */ \
-      clockTicks++;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -1686,20 +1798,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1709,11 +1823,16 @@
   case BASE+5:\
     {\
        /* OP Rd,Rb,Rm ASR Rs */ \
-      clockTicks++;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift < 32) {\
         if(shift) {\
           LOGICAL_ASR_REG\
@@ -1730,20 +1849,22 @@
         }\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1753,11 +1874,16 @@
   case BASE+7:\
     {\
        /* OP Rd,Rb,Rm ROR Rs */\
-      clockTicks++;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         shift &= 0x1f;\
         if(shift) {\
@@ -1771,20 +1897,22 @@
         C_OUT = (value & 0x80000000 ? true : false);\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1812,26 +1940,34 @@
       int dest = (opcode >> 12) & 0x0F;\
       bool C_OUT = C_FLAG;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         LOGICAL_ROR_IMM\
       } else {\
         value = opcode & 0xff;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1848,26 +1984,34 @@
       int shift = (opcode >> 7) & 0x1F;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         ARITHMETIC_LSL_REG\
       } else {\
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1882,26 +2026,34 @@
       int shift = (opcode >> 7) & 0x1F;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         ARITHMETIC_LSR_REG\
       } else {\
         value = 0;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1916,6 +2068,12 @@
       int shift = (opcode >> 7) & 0x1F;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         ARITHMETIC_ASR_REG\
       } else {\
@@ -1924,20 +2082,22 @@
         } else value = 0;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1952,26 +2112,34 @@
       int shift = (opcode >> 7) & 0x1F;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
          ARITHMETIC_ROR_REG\
       } else {\
          ARITHMETIC_RRX_REG\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -1981,11 +2149,16 @@
   case BASE+1:\
     {\
       /* OP Rd,Rb,Rm LSL Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -1996,20 +2169,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -2019,11 +2194,16 @@
   case BASE+3:\
     {\
       /* OP Rd,Rb,Rm LSR Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         if(shift == 32) {\
           value = 0;\
@@ -2034,20 +2214,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -2057,11 +2239,16 @@
   case BASE+5:\
     {\
       /* OP Rd,Rb,Rm ASR Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift < 32) {\
         if(shift) {\
            ARITHMETIC_ASR_REG\
@@ -2074,20 +2261,22 @@
         } else value = 0;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -2097,11 +2286,16 @@
   case BASE+7:\
     {\
       /* OP Rd,Rb,Rm ROR Rs */\
-      clockTicks++;\
       int base = (opcode >> 16) & 0x0F;\
       int shift = reg[(opcode >> 8)&15].B.B0;\
       int dest = (opcode>>12) & 15;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       if(shift) {\
         shift &= 0x1f;\
         if(shift) {\
@@ -2113,20 +2307,22 @@
         value = reg[opcode & 0x0F].I;\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -2154,24 +2350,32 @@
       int base = (opcode >> 16) & 0x0F;\
       int dest = (opcode >> 12) & 0x0F;\
       u32 value;\
+      if ((dest == 15)||((opcode & 0x02000010)==0x10))\
+      {\
+        clockTicks = 1+codeTicksAccess32(armNextPC);\
+        if ((opcode & 0x02000010)==0x10)\
+          clockTicks++;\
+      }\
       {\
         ARITHMETIC_ROR_IMM\
       }\
       if(dest == 15) {\
+        clockTicks+=2+codeTicksAccessSeq32(armNextPC)+codeTicksAccessSeq32(armNextPC);\
         OPCODE2\
         /* todo */\
         if(opcode & 0x00100000) {\
-          clockTicks++;\
           CPUSwitchMode(reg[17].I & 0x1f, false);\
         }\
         if(armState) {\
           reg[15].I &= 0xFFFFFFFC;\
           armNextPC = reg[15].I;\
           reg[15].I += 4;\
+          ARM_PREFETCH;\
         } else {\
           reg[15].I &= 0xFFFFFFFE;\
           armNextPC = reg[15].I;\
           reg[15].I += 2;\
+          THUMB_PREFETCH;\
         }\
       } else {\
         OPCODE \
@@ -2179,9 +2383,16 @@
     }\
     break;
 
-  u32 opcode = CPUReadMemoryQuick(armNextPC);
+  u32 opcode = cpuPrefetch[0];
+  cpuPrefetch[0] = cpuPrefetch[1];
+
+  busPrefetch = false;
+  if (busPrefetchCount & 0xFFFFFE00)
+    busPrefetchCount = 0x100 | (busPrefetchCount & 0xFF);
 
-  clockTicks = memoryWaitFetch32[(armNextPC >> 24) & 15];
+
+  clockTicks = 0;//codeTicksAccessSeq32(armNextPC)+1;
+  int oldArmNextPC = armNextPC;
 
 #ifndef FINAL_VERSION
   if(armNextPC == stop) {
@@ -2191,6 +2402,8 @@
 
   armNextPC = reg[15].I;
   reg[15].I += 4;
+  ARM_PREFETCH_NEXT;
+
   int cond = opcode >> 28;
   // suggested optimization for frequent cases
   bool cond_res;
